<script setup lang="ts">
import { onMounted, provide, ref } from 'vue'
import SalaryList from '@/components/SalaryList.vue'
import type { User } from '@/types/User'
import { useUserStore } from '@/stores/user'
import { useBranchStore } from '@/stores/branch'
import { useAuthStore } from '@/stores/auth'
import { useRoute, useRouter } from 'vue-router'
import { usePermissionStore } from '@/stores/permission'
import { useCheckInStore } from '@/stores/checkIn'

const router = useRouter()
const route = useRoute()

const userStore = useUserStore()
const checkinStore = useCheckInStore()
const branchStore = useBranchStore()
const permissionStore = usePermissionStore()
const authStore = useAuthStore()
const p = ref<User[]>([])
const users = ref<User[]>([])

function getUser() {
  if (authStore.getCurrentUser()?.role === 'Owner') {
    users.value = userStore.users
  } else if (authStore.getCurrentUser()?.role === 'Manager') {
    users.value = branchStore.userAtBranch
  } else if (authStore.getCurrentUser()?.role === 'Staff') {
    users.value = branchStore.userAtBranch
  }
}

provide('selectedUser', p)

const userList: User[] | any = ref(users)

onMounted(async () => {
  await checkinStore.getCheckIns()
  await userStore.getUsersByBranch(authStore.getCurrentUser()?.branch?.id || 0)
  if (!permissionStore.isEmp()) {
    permissionStore.pushMember()
  }
  getUser()
})
</script>

<template>
  <SalaryList :users="userList"></SalaryList>
</template>
